<?php
/*
* 2007-2012 Biztec.sk
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to info@biztec.sk so we can send you a copy immediately.
*
*  @author CEE Investments s.r.o. <info@biztec.sk>
*  @copyright  2007-2012 CEE Investments s.r.o.
*  @version  Release: 1.0
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

if (!defined('_CAN_LOAD_FILES_'))
	exit;
	
class blockconvert extends Module
{
	public function __construct()
	{
		$this->name = 'blockconvert';
		$this->tab = 'advertising_marketing';
		$this->version = '1.0';

		parent::__construct();

		$this->displayName = $this->l('Convert Experiments module');
		$this->description = $this->l('Integrate your Convert insights script on your site.');
	}
	
	public function install()
	{
		return (parent::install() AND Configuration::updateValue('blockconvert', '')  AND Configuration::updateValue('blockconvert_type', 0) && $this->registerHook('Header'));
	}
	
	public function uninstall()
	{
		//Delete configuration			
		return (Configuration::deleteByName('blockconvert') AND Configuration::deleteByName('blockconvert_type') AND parent::uninstall());
	}
	
	public function getContent()
	{
		// If we try to update the settings
		$output = '';
		if (isset($_POST['submitModule']))
		{	
			Configuration::updateValue('blockconvert', (($_POST['blockconvert'] != '') ? $_POST['blockconvert']: ''));
			Configuration::updateValue('blockconvert_type', (($_POST['blockconvert_type'] != '') ? $_POST['blockconvert_type']: ''));				
			$output = '<div class="conf confirm">'.$this->l('Configuration updated').'</div>';
		}
		
		return '
		<h2>'.$this->displayName.'</h2>
		'.$output.'
		<form action="'.Tools::htmlentitiesutf8($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset class="width4">
				<label for="blockconvert_type">'.$this->l('Integration type: ').'</label>
				<input type="radio" name="blockconvert_type" value="0" '. (Tools::safeOutput(Configuration::get('blockconvert_type')) == 0 ? 'checked="checked"' : '').' /> Simple&nbsp;&nbsp;&nbsp; 
				<input type="radio" name="blockconvert_type" value="1" '. (Tools::safeOutput(Configuration::get('blockconvert_type')) == 1 ? 'checked="checked"' : '').' /> Advanced*
				<div class="clear">&nbsp;</div>			
				<label for="blockconvert">'.$this->l('Your Project Number: ').'</label>
				<input type="text" id="blockconvert" name="blockconvert" value="'.Tools::safeOutput((Configuration::get('blockconvert') != "") ? Configuration::get('blockconvert') : "").'" />
				<div class="clear">&nbsp;</div>
				<p>* You will have to edit themes/YourTemplateName/<strong>header.tpl</strong>. Please add <strong>{$convert_variable}</strong> right after title end tag &lt;/title&gt;</p>
				<br /><center><input type="submit" name="submitModule" value="'.$this->l('Update settings').'" class="button" /></center>
			</fieldset>
		</form>';
	}
	
	public function hookHeader()
	{
		global $smarty;
		global $cookie;
		
		$id_lang = (int)$cookie->id_lang; 
		$id_product = (int)(Tools::getValue('id_product'));
		$id_category = (int)(Tools::getValue('id_category'));
		
		if($id_product>0)
		{
			$product = new Product((int)($id_product), false, $id_lang);
			$categories = $product->getProductCategoriesFull($id_product, $id_lang);
		
			foreach($categories as $c)
			{
				$category_name .= $c["name"] . ';';
				$category_id .= $c["id_category"] . ';';
			}
			$category_name = substr($category_name,0,-1);
			$category_id = substr($category_id,0,-1);
			$product_name = $product->name;
			$product_sku = $product->reference;
			if(version_compare(_PS_VERSION_, '1.5.0.0', '<'))
				$product_price = $product->getPrice(true, null, 2);
			else
				$product_price = $product->getPrice(true, $product->getDefaultIdProductAttribute(),2);
		}
		elseif($id_category>0)
		{
			$cat =  new Category($id_category);
			$category_name = $cat->getName($id_lang);
			$category_id = $id_category;
			$product_name = null;
			$product_sku = null;
			$product_price = null;
		}
		else
		{
			$category_name = null;
			$category_id = null;
			$product_name = null;
			$product_sku = null;
			$product_price = null;
		}
		
		$page_type = $smarty->tpl_vars["page_name"]->value;
	
		$customer_id = null;
		if (isset($cookie->id_customer))
			$customer_id = $cookie->id_customer;
		
		$plugin_id = '102';

		$output =  null;
		$convert = Configuration::get('blockconvert');
		$convert_type = Configuration::get('blockconvert_type');
		if ($convert) {
			$smarty->assign(array('convert' => $convert));
			$smarty->assign(array('customer_id' => $customer_id));
			
			$smarty->assign(array('category_name' => $category_name));
			$smarty->assign(array('category_id' => $category_id));
			$smarty->assign(array('product_name' => $product_name));
			$smarty->assign(array('product_sku' => $product_sku));
			$smarty->assign(array('product_price' => $product_price));
			$smarty->assign(array('plugin_id' => $plugin_id));
			
			if($page_type == 'order-confirmation')
			{
				$cart_id = (int)(Tools::getValue('id_cart'));
				$cart = new Cart($cart_id);

				$revenue = $cart->getOrderTotal(true, Cart::BOTH_WITHOUT_SHIPPING);
				$products_cnt = $cart->nbProducts();
				$transaction_id = (int)(Tools::getValue('id_order'));
				
				$smarty->assign(array('revenue' => $revenue));
				$smarty->assign(array('products_cnt' => $products_cnt));
				$smarty->assign(array('transaction_id' => $transaction_id));
			}
			else
			{
				global $cart;
				if($cart != null)
				{
					$revenue = $cart->getOrderTotal(true, Cart::BOTH_WITHOUT_SHIPPING);
					$products_cnt = $cart->nbProducts();
					$smarty->assign(array('revenue' => $revenue));
					$smarty->assign(array('products_cnt' => $products_cnt));
				}
				if($page_type == 'order')
				{
					$step = (int)(Tools::getValue('step'));
					if($step == 0)
						$page_type = 'cart-summary';
					elseif($step == 1)
					{
						if(isset($cookie->id_customer))
							$page_type = 'cart-address';
						else
							$page_type = 'cart-login';
					}
					else
					{
						$addressSet = (Tools::getValue('processAddress'));
						$carrierSet = (Tools::getValue('processCarrier'));
						if($addressSet)
							$page_type = 'cart-delivery';
						elseif($carrierSet)
							$page_type = 'cart-payment';
					}
				}
			}
			$smarty->assign(array('page_type' => $page_type));
		
			if($convert_type==0)
				$output = $this->display(__FILE__, 'blockconvert.tpl');
			else
				$smarty->assign('convert_variable', $this->display(__FILE__, 'blockconvert.tpl'));	
		}
		return $output;
	}
}
?>
